import java.util.Properties;
import javax.naming.*;
import javax.naming.directory.*;

class SearchRef  {
  public static void main(String[] args) {
    Properties env=utils.getProps("test.properties");
    String base = env.getProperty("example.search.ref.base");
    String filter = env.getProperty("example.search.ref.filter");
    SearchControls constraints = new SearchControls();
    constraints.setSearchScope(SearchControls.SUBTREE_SCOPE);
    DirContext ctx = new InitialDirContext(env);
    try {
      while(true) {
	try {
	  NamingEnumeration results
	    = ctx.search(base,filter,constraints);
	  utils.printSearchEnums(results);
	  return;
	} catch (ReferralException e) {
	  if (!utils.followReferral(e))
	    return;
	  ctx=(DirContext) e.getReferralContext();
	}
      }
    } catch (NamingException e) {
      System.out.println("Search Failed "+e.getMessage());
    }
  }
}
